import os


# list all file
def list_all_file(path):
    file_list = []
    for root, dirs, files in os.walk(path):
        for file in files:
            file_list.append(os.path.join(root, file))
    return file_list


def remove_files():
    os.system('rm compiler')
    allDir = [
        'src/CodeGen', 'src/HIR', 'src/OptimizePass', 'src/front', 'include/CodeGen', 'include/HIR',
        'include/OptimizePass', 'include/front'
    ]
    for directory in allDir:
        if os.path.exists(directory):
            os.system('rm -r ' + directory)


# compile all file
def compile_all_file(file_list):
    linkedDic = set()
    linkCmd = ''
    fileList = []

    for file in file_list:
        suffix = file.split('.')[-1]
        if suffix == 'hpp' or suffix == 'hh' or suffix == 'H' or suffix == 'hxx' or suffix == 'h':
            isCppProject = True
            linkPath = '/'.join(file.split('/')[:-1])
            if linkPath not in linkedDic:
                linkCmd += ' -I ' + linkPath
                linkedDic.add(linkPath)
        elif suffix == 'cpp' or suffix == 'CPP' or suffix == 'c++' or suffix == 'cxx' or suffix == 'C' or suffix == 'cc' or suffix == 'cp':
            isCppProject = True
            fileList.append(file)
        elif suffix == 'c' or suffix == 'C':
            fileList.append(file)

    # clang++ -std=c++17 -O2
    if isCppProject:
        command = 'clang++ -std=c++17 -O0 -o compiler -g' + linkCmd + ' ' + ' '.join(fileList)
        os.system(command)
        print(command)


remove_files()
fileList = list_all_file('.')
compile_all_file(fileList)
