#ifndef __LOOPINVMOTION_HH__
#define __LOOPINVMOTION_HH__

#include "Dominators.hh"
#include "LoopSearch.hh"
#include "Pass.hh"

#include <vector>

class LoopInvMotion : public Pass {
  public:
    LoopInvMotion(Module *m) : Pass(m), _loops(m), _dom(m) {}
    void run();

  private:
    loop_search _loops;
    Dominators _dom;
    std::vector<std::shared_ptr<bb_set_t>> get_sub_loops(std::shared_ptr<bb_set_t>);
    void get_all_doms(BasicBlock *, std::unordered_set<BasicBlock *> &);
    int counter = 0;
};

#endif  // #ifndef __LOOPINVMOTION_HH__