#include "SimplifyCFG.hh"

#include "logging.hpp"

void SimplifyCFG::run() {
    for (auto _f : m_->get_functions()) {
        _func = _f.get();
        merge_double_br();
    }
}

// br的目标地址是另一条无条件br
void SimplifyCFG::merge_double_br() {
    vector<shared_ptr<BasicBlock>> wait_del;
    for (auto bb : _func->get_basic_blocks()) {
        if (bb == _func->get_entry_block())
            continue;
        auto first_instr = *bb->get_instructions().begin();

        // debug
        // if (bb->get_name() == "label_body62") {
        //     std::cout << m_->print();
        // }
        
        if (first_instr->is_br() && first_instr->get_num_operand() == 1 &&
            bb->get_use_list().size() == bb->get_pre_basic_blocks().size()) {
            auto succ = *bb->get_succ_basic_blocks().begin();
            bb->replace_all_use_with(succ->shared_from_this());
            succ->remove_pre_basic_block(bb.get());
            for (auto pre : bb->get_pre_basic_blocks()) {
                pre->remove_succ_basic_block(bb.get());
                pre->add_succ_basic_block(succ);
                succ->add_pre_basic_block(pre);
                // auto pre_terminator = pre->get_terminator();
                // bb->remove_use(pre_terminator.get());
                // for (int op_n = 0; op_n < pre_terminator->get_num_operand(); op_n++) {
                //     if (pre_terminator->get_operand(op_n).get() == bb.get()) {
                //         pre_terminator->set_operand(op_n, succ->shared_from_this());
                //         break;
                //     }
                // }
            }
            wait_del.push_back(bb);
        }
    }
    for (auto del_bb : wait_del) {
        LOG_DEBUG << "remove basicblock " << del_bb->get_name();
        _func->remove(del_bb);
    }
}